<%@LANGUAGE="VBSCRIPT" CODEPAGE="1252"%>

<% 

'############################################################################################
'#  asp_speedchex_serverlinkadvanced.asp
'############################################################################################
'#
'# This script is a functioning example that shows ASP programmers how to utilize 
'# the SpeedChex ServerLink Advanced API to submit checking account and customer 
'# data to SpeedChex for authorization.  The script also shows sample code for parsing
'# the results sent back from SpeedChex.  Please contact your support representative
'# if you do not have a copy of the SpeedChex ServerLink Advanced API documentation.
'#
'# In order to establish an HTTPS connection, pass data to the SpeedChex Gateway and receive
'# a response using this sample code, you will need have ServerXMLHTTP installed.  This is 
'# installed by default in Windows 2003, Windows XP SP1, and Windows 2000 SP3.  It is also
'# included in Microsoft's .Net platform.  Documentation for ServerXMLHTTP can be found at:
'# http://msdn.microsoft.com/library/default.asp?url=/library/en-us/xmlsdk/html/97884cf6-5fdf-4b1f-8273-73c0e098b8f3.asp 
'#
'# This script expects to receive the following data fields as POST or QUERY STRING (GET)
'# variables:
'#     
'#     InvoiceNumber
'#     CheckAmount
'#     CustomerID
'#     FirstName
'#     LastName
'#     Company
'#     Address
'#     City
'#     State
'#     Zip
'#     Phone
'#     Email
'#     BankName
'#     AccountType
'#     AccountClass
'#     RoutingNumber
'#     CheckNumber
'#     AccountNumber
'#'# The data format specifications and rules about which fields are required and which fields
'# are optional can be found in the SpeedChex ServerLink Advanced API documentation.
'# 
'# Programmers may use all or any part of this code and can make whatever modifications are
'# necessary to integrate this code into their perl application.
'#
'# When you are ready to test this code, you will need to change the MerchantID,
'# LoginName, and Password fields to those provided by your SpeedChex support representative.
'#
'###############################################################################################


'##############################################
'#   Declare Variables
'##############################################
 Dim ReferenceID, PaymentDirection, CheckAmount, DateScheduled, CustomerID, CustomerName, Company
 Dim Address1, Address2, City, State, Zip, Phone, Email, SendEmailToCustomer
 Dim BankName, AccountType, AccountClass, RoutingNumber, CheckNumber, AccountNumber, SECCode

 
'##############################################                             '######################################################
'#   Initialize Variables                          	                        '#  Use these Request objects for CheckTemplate.htm
'##############################################							    '######################################################
 ReferenceID = "12345"                                                      '#  Request("InvoiceNumber")
 PaymentDirection = "FromCustomer"                                          '#
 CheckAmount = "44.00"                                                      '#  Request("Amount")
 CustomerID = ""                                                       		'#  Request("CustomerID")
 CustomerName = "Joe Buyer"                                                 '#  Request("FirstName") & " " & Request("LastName")
 Company = "Joe, Inc."                                                      '#  Request("Company")
 Address1 = "1234 Purchaser Lane"                                           '#  Request("Address1")
 Address2 = ""                                                              '#  Request("Address2")
 City = "New York"                                                          '#  Request("City")
 State = "NY"                                                               '#  Request("State")
 Zip = "12345"                                                              '#  Request("Zip")
 Phone = "(555) 222-1234"                                                   '#  Request("Phone")
 SSN = ""                                                                   '#
 SECCode = "WEB"                                                            '#
 SendEmailToCustomer = "Yes"                                                '#  
 Email = "jbuyer@217hosting.com"                                            '#  Request("Email")
 BankName = "Test Bank"                                                     '#  Request("BankName")
 AccountType = "Personal"                                                   '#  Request("AccountType")
 AccountClass = "Checking"                                                  '#  Request("AccountClass")
 RoutingNumber = "111000025"                                                '#  Request("RoutingNumber")
 CheckNumber = "12346"                                                      '#  Request("CheckNumber")
 AccountNumber = "987654321"                                                '#  Request("AccountNumber")
 DateScheduled = String(2-Len(Month(Date)),"0") & Month(Date) & _             
                 String(2-Len(Day(Date)),"0") & Day(Date) & Year(Date)      
				 'this code puts the date in the required format MMDDYYYY     
 
 

'##############################################
'#  Build HTTPS GET string
'##############################################
 Dim URL
 
 URL = "https://www.speedchex.com/datalinks/merchants/serverlink-advanced.asp"

 ParamList = "MerchantID=2001" & _
             "&GateID=test" & _
             "&GateKey=test" & _
             "&ReferenceID=" & Server.URLEncode(ReferenceID) & _
             "&PaymentDirection=" & PaymentDirection & _
             "&CheckAmount=" & Server.URLEncode(CheckAmount) & _
             "&DateScheduled=" & DateScheduled & _
             "&CustomerID=" & Server.URLEncode(CustomerID) & _
             "&CustomerName=" & Server.URLEncode(CustomerName) & _
             "&Company=" & Server.URLEncode(Company) & _
             "&Address1=" & Server.URLEncode(Address1) & _
             "&Address2=" & Server.URLEncode(Address2) & _
             "&City=" & Server.URLEncode(City) & _
             "&State=" & Server.URLEncode(State) & _
             "&Zip=" & Server.URLEncode(Zip) & _
             "&Phone=" & Server.URLEncode(Phone) & _
             "&Email=" & Server.URLEncode(Email) & _
             "&SendEmailToCustomer=Yes" & _
             "&BankName=" & Server.URLEncode(BankName) & _
             "&AccountType=" & Server.URLEncode(AccountType) & _
             "&AccountClass=" & Server.URLEncode(AccountClass) & _
             "&RoutingNumber=" & Server.URLEncode(RoutingNumber) & _
             "&CheckNumber=" & Server.URLEncode(CheckNumber) & _
             "&AccountNumber=" & Server.URLEncode(AccountNumber) & _
			 "&SECCode=" & SECCode & _
			 "&TestMode=Off"

Response.Write("<b>HTTP POST string sent to SpeedChex:</b><BR>")
Response.Write(ParamList)

 
'############################################
'# Establish WinHTTP connection
'############################################

'For Windows 2003, Windows 2000, and Windows XP Users
 Set objWinHttp = Server.CreateObject("MSXML2.ServerXMLHTTP")

 'Post the data to the serverlink-advanced URL  
  objWinHttp.Open "POST", URL, False

  objWinHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
  objWinHttp.Send ParamList

 'Parse the response
  Result = objWinHttp.ResponseText
  
 Set objWinHTTP = Nothing

 'Show result text from check authorization attempt
  Response.Write("<BR><BR><BR><b>Response from SpeedChex Gateway:</b><BR>")
  Response.Write(Result)

'#######################################################
'#  Parse the response from SpeedChex Gateway
'#    Note: These output messages are just examples.   
'#          Modify this code to control how you want
'#          to interact with your customer if there
'#          is a problem.
'#######################################################

Response.Write("<BR><BR><BR><b>Parsed Response:</b><BR>")

'Parse results into ResultArray variable.
 ResultArray = split(Result,",")

 If UBound(ResultArray) < 2 Then 
   Response.Write("Communication Error with SpeedChex Gateway.  Invalid Response Received.")
 Else
   If ResultArray(0) = "ReturnCode=000" Then
    'Put code here to conclude the customer's transaction
     Response.Write("Authorization Successful")
   Else
    'Parse ResultArray into corresponding variables.  NVPair is short for Name Value Pair
     ReturnCodeNVPair = split(ResultArray(0),"=")
       ReturnCodeName = ReturnCodeNVPair(0)
	   ReturnCodeValue = ReturnCodeNVPair(1)

     ErrorDescriptionNVPair = split(ResultArray(1),"=")
	   ErrorDescriptionName = ErrorDescriptionNVPair(0)
	   ErrorDescriptionValue = ErrorDescriptionNVPair(1)

 	 ErrorFieldNVPair = split(ResultArray(2),"=")
	   ErrorFieldName = ErrorFieldNVPair(0)
	   ErrorFieldValue = ErrorFieldNVPair(1)

 	 TrackingCodeNVPair = split(ResultArray(3),"=") 
	   TrackingCodeName = TrackingCodeNVPair(0)
	   TrackingCodeValue = TrackingCodeNVPair(1)

     Select Case ReturnCodeValue  
       Case "001"
	    'Invalid Login
   	     Response.Write("You are not using valid login information.  &nbsp;This is not a customer issue.")

       Case "002"
	    'Required Field Missing
	     Response.Write("A field required by SpeedChex (" & ErrorFieldValue & ") has not been sent. &nbsp;This is not a customer issue.")

	   Case "003"
	    'Field Value Violates Format Constraint
 	    '  We request that you have your program do error checking instead of using SpeedChex to do error
 	    '  checking for you.  If you get this error, you will want to fix your error checking process.
        '  The ErrorFieldValue variable will show you what field has invalid data.
         Response.Write("Invalid data contained in the " & ErrorFieldValue & " field.")

	   Case "004"
	    'Field Value Exceeds Maximum Length
 	    '  We request that you have your program do error checking instead of using SpeedChex to do error
 	    '  checking for you.  If you get this error, you will want to fix your error checking process.
        '  The ErrorFieldValue variable will show you what field has invalid data.
	     Response.Write("Data exceeds maximum length in the " & ErrorFieldValue & " field.")

	   Case "005"
	    'Routing Number Fails Authentication
 	    '  The customer has entered an invalid routing number.
         Response.Write("You have entered an invalid routing number.")

	   Case "006" 
	    'Transaction Request Already Processed
 	    '  SpeedChex has already processed this check and will not process it again
         Response.Write("This check has already been accepted and does not need to be submitted again.")

	   Case "007"
	    'Please Contact Support Representative
 	     Response.Write("Return Code 007 is an internal security response and is not a customer related issue.")

	   Case "008"
	    'Failed Verification
 	    '  The ErrorDescriptionValue variable will contain the Express Verify Response Code and  
	    '  Response Text separated by a colon.  See document SpeedChex_ExpressVerify_Response_Codes.doc 
	    '  for a list of all possible negative response codes.
					
        'Get the SpeedChex Express Verify Response Text
         ExpressVerifyResponse = split(ErrorDescriptionValue,":")			
         ExpressVerifyResponseCode = ExpressVerifyResponse(0)
		 ExpressVerifyResponseText = ExpressVerifyResponse(1)
					  
         Response.Write("Account Failed Verification: &nbsp;We apologize, but we cannot accept a check on this bank account. &nbsp;The account has " &_
                        "failed verification due to its current status.<BR><BR>Your business is very important to us. &nbsp;Please review the " &_
						"routing number and the account number for any input errors. &nbsp;If you are sure the account information is correct, you " &_
		  	            "may want to contact your banking institution to discuss the current status of your account and how it may have affected " &_
						"this transaction.")

	   Case Else
	    'All other response codes
         Response.Write("This response code (" & ReturnCodeValue & ") indicates an unknown error and requires assistance " &_
 		                "from the SpeedChex technical support staff.")
     End Select
   End If ' If ($ReturnCodeNVPair eq 'ReturnCode=000') Else
 End If


%>